/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.workingbriefcase.vista.administrador;

import com.workingbriefcase.persistencia.controladores.PaisJpaController;
import com.workingbriefcase.persistencia.entities.Pais;
import com.workingbriefcase.utilidades.MetodosUtil;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author hola
 */
public class FrmPais extends javax.swing.JInternalFrame {
    PaisJpaController pc = new PaisJpaController();
    int codigo = 0;
    MetodosUtil mu = new MetodosUtil();
    /**
     * Creates new form FrmPais
     */
    public FrmPais() {
        initComponents();
        llenarTabla();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtNombre = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        txtGentilicio = new javax.swing.JTextField();
        btnInsertar = new javax.swing.JButton();
        btnModificar = new javax.swing.JButton();
        btnEliminar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtablaDatos = new javax.swing.JTable();

        setClosable(true);

        jLabel1.setText("Pais");

        jLabel2.setText("Nombre:");

        txtNombre.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtNombreKeyTyped(evt);
            }
        });

        jLabel3.setText("Gentilicio:");

        txtGentilicio.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtGentilicioKeyTyped(evt);
            }
        });

        btnInsertar.setText("Insertar");
        btnInsertar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnInsertarActionPerformed(evt);
            }
        });

        btnModificar.setText("Modificar");
        btnModificar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnModificarActionPerformed(evt);
            }
        });

        btnEliminar.setText("Eliminar");
        btnEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEliminarActionPerformed(evt);
            }
        });

        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        jtablaDatos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jtablaDatos.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jtablaDatosMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jtablaDatos);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(61, 61, 61)
                .addComponent(btnInsertar)
                .addGap(57, 57, 57)
                .addComponent(btnModificar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 55, Short.MAX_VALUE)
                .addComponent(btnEliminar)
                .addGap(82, 82, 82)
                .addComponent(btnCancelar)
                .addGap(126, 126, 126))
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(287, 287, 287)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(135, 135, 135)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2))
                        .addGap(32, 32, 32)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(txtNombre)
                            .addComponent(txtGentilicio, javax.swing.GroupLayout.DEFAULT_SIZE, 246, Short.MAX_VALUE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(jLabel1)
                .addGap(30, 30, 30)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtGentilicio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(42, 42, 42)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnInsertar)
                    .addComponent(btnModificar)
                    .addComponent(btnEliminar)
                    .addComponent(btnCancelar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnInsertarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnInsertarActionPerformed
        insertar();
    }//GEN-LAST:event_btnInsertarActionPerformed

    private void btnModificarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnModificarActionPerformed
        modificar();
    }//GEN-LAST:event_btnModificarActionPerformed

    private void btnEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEliminarActionPerformed
       eliminar();
    }//GEN-LAST:event_btnEliminarActionPerformed

    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
        cancelar();
    }//GEN-LAST:event_btnCancelarActionPerformed

    private void txtNombreKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtNombreKeyTyped
        mu.soloLetras(evt);
    }//GEN-LAST:event_txtNombreKeyTyped

    private void txtGentilicioKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtGentilicioKeyTyped
        mu.soloLetras(evt);
    }//GEN-LAST:event_txtGentilicioKeyTyped

    private void jtablaDatosMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jtablaDatosMouseClicked
        int fila = this.jtablaDatos.getSelectedRow();
        codigo = Integer.parseInt(String.valueOf(this.jtablaDatos.getValueAt(fila, 0)));
        txtNombre.setText(String.valueOf(this.jtablaDatos.getValueAt(fila, 1)));
        txtGentilicio.setText(String.valueOf(this.jtablaDatos.getValueAt(fila, 2)));
                
    }//GEN-LAST:event_jtablaDatosMouseClicked
    
    Pais llenar(){
        Pais p = new Pais();
        p.setNombre(txtNombre.getText());
        p.setBorrado(true);
        p.setGentilicio(txtGentilicio.getText());
        p.setId(codigo);
        return p;
    }
    
    void limpiar(){
        txtNombre.setText("");
        txtGentilicio.setText("");
    }
    
    boolean cajasVacias(){
        boolean estado = true;
        if(txtNombre.getText().isEmpty()){
            estado = false;
        }
        if(txtGentilicio.getText().isEmpty()){
            estado = false;
        }
        return estado;
    }
    
    void insertar(){
        try {
            if(cajasVacias()){
                pc.create(llenar());
                JOptionPane.showMessageDialog(null, "Datos ingresados correctamente.");
                     llenarTabla();
                     limpiar();
            }else{
                JOptionPane.showMessageDialog(null, "Aun quedan campos por completar.");
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al insertar los datos." + e.toString());
        }
    }
     void modificar(){
        try {
            if(cajasVacias()){
                if(JOptionPane.showConfirmDialog(null, "Desea modificar los datos?","Modificar", JOptionPane.YES_NO_OPTION) == 0){
                       pc.edit(llenar());
                       JOptionPane.showMessageDialog(null, "Datos modificados correctamente.");
                            llenarTabla();
                            limpiar();
                }
             
            }else{
                JOptionPane.showMessageDialog(null, "Aun quedan campos por completar.");
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al modificar los datos." + e.toString());
        }
    }
      void eliminar(){
        try {
            if(cajasVacias()){
                if(JOptionPane.showConfirmDialog(null, "Desea eliminar los datos?","Eliminar", JOptionPane.YES_NO_OPTION) == 0){
                       pc.destroy(llenar().getId());
                       JOptionPane.showMessageDialog(null, "Datos eliminar correctamente.");
                            llenarTabla();
                            limpiar();
                }
            }else{
                JOptionPane.showMessageDialog(null, "Aun quedan campos por completar.");
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Error al eliminar los datos." + e.toString());
        }
    }
      void cancelar(){
           if(JOptionPane.showConfirmDialog(null, "Desea cancelar la accion?","Cancelar", JOptionPane.YES_NO_OPTION) == 0){
                      limpiar();
                  
                }
      }
      
      void llenarTabla(){
          try {
              List<Pais> lista = pc.findPaisEntities();
              String[] headers = {"Codigo","Nombre","Gentilicio"};
              DefaultTableModel modelo = new DefaultTableModel(null, headers);
              Object[] obj = new Object[3];
              Pais p = new Pais();
              for (int i = 0; i < lista.size(); i++) {
                  p = (Pais)lista.get(i);
                  obj[0] = p.getId();
                  obj[1] = p.getNombre();
                  obj[2] = p.getGentilicio();
                  modelo.addRow(obj);
              }
              this.jtablaDatos.setModel(modelo);
          } catch (Exception e) {
              JOptionPane.showMessageDialog(null, "Error al mostrar los datos." + e.toString());
          }
      }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancelar;
    private javax.swing.JButton btnEliminar;
    private javax.swing.JButton btnInsertar;
    private javax.swing.JButton btnModificar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jtablaDatos;
    private javax.swing.JTextField txtGentilicio;
    private javax.swing.JTextField txtNombre;
    // End of variables declaration//GEN-END:variables
}
